import java.util.Iterator;
import java.util.ArrayList;


public class Agenda{

	ArrayList wege;

	public Agenda(){
		wege = new ArrayList();
	}


	// Weg in die Agenda einfgen (je nach Suchverfahren
	// vorne/hinten/...  Unterklassen bilden)
	public void fuegeWegEin(Weg w){
		// Weg w vorne in die Agenda einfgen (TiefenSuche)
		wege.add(0, w);
	}
	
	public void fuegeWegeEin(Iterator i){
		while(i.hasNext()){
			Weg w = (Weg)i.next();
			fuegeWegEin(w);
		}
	}
	
	// Vordersten Weg in der Agenda liefern und lschen
	public Weg liefereErstenWeg() throws AgendaEmptyException{

		// Agenda leer: Exception werfen		
		if(wege.isEmpty())
			throw new AgendaEmptyException("Agenda leer!");
		
		// Weg nehmen
		Weg w = (Weg)(wege.get(0));
		// Weg aus Agenda entfernen
		wege.remove(0);
		// Weg zurckgeben
		return w;
	}
	
	// :-)
	public Weg erstenWegFuerPaint(){
		if(wege.isEmpty()) return new Weg();
		return (Weg)wege.get(0);
	}

	public boolean bistDuLeer(){
		return wege.isEmpty();
	}

	// Agenda ausgeben
	public void print(){
		System.out.print("Inhalt der Agenda:[");
		Iterator i = wege.iterator();
		while(i.hasNext()){
			((Weg)i.next()).print();
		}
		System.out.println("]");
	}
	
	public String toString(){
	StringBuffer buf= new StringBuffer("[ ");

		Iterator i = wege.iterator();
		while(i.hasNext()){
			buf.append(((Weg)i.next()).toString());
			buf.append(", ");
			System.out.print(".");
		}
		if(buf.length() > 2)
			buf.replace(buf.length()-2, buf.length()-1,"]");
		else buf.append("]");
			


		return buf.toString();
	}
	
	
}
